"use strict";
this.name			= "Loan Repayment Script";
this.author			= "ocz";
this.copyright		= "2015 ocz";
this.licence		= "CC BY-NC-SA 4.0";
this.version		= "0.2.0";


//if (missionVariables.loanData || clock.seconds < 180058019400) {
// If there is no loan savedata (expected reason: the loan has been paid off) and it isn't the beginning of a new game, the whole script is omitted. 

// You can change values here to make adjustments.
this._loanAllowanceBase = 500;			//In credits.
this._loanAllowanceMinimum = 50;

this._interestRate = 0.1;				//In percent.
this._repaymentRate = 1;
this._defaultRate = 5;
this._outOfScheduleRate = 5;

this._loanForcedSaleCounterLimit = 3;	//In whole numbers. Number of warnings given, before selling off the players commodities and ship.
this._loanForcedSellPrice = 50;			//In percent. Price the player is getting for his ship.
this._loanForcedSellPriceBonus = 50;	//In credits. Money the player will be granted.

this._loanStartDate = 180057945600; 	//In seconds.	//180058018400;
this._intervalTotalTurns = 10			//In whole numbers. Number of turns (e.g.dockings) before a new rate is due.
this._intervalTurnsTotalDaysCounter = 1;//In whole numbers. 1 means turn counter increases every passing day.
this._intervalTurnDayCountReset = -1;	//In whole numbers. Negative values mean additional days gained after docking, before counting starts.
this._loanRepaymentInterval = 604800;	//In seconds. For example: 604800 is one week.

// OXP initialisation values. Do not edit unless you know what you are doing. 
this._loanBalance = 0.0;
this._partialPayment = 0.0;
this._partialPaymentLeft = 0.0;
this._outOfSchedulePayment = 0.0;
this._lastLoanBalance = 0.0;
//this._expectedLoanBalance = 0.0;
this._loanCredibility = 0;
this._loanGalaxy = 0;

this._loanInterval = 0;

this._intervalTurn = 0;
this._intervalTurnBased = true;

this._payment = 0.0;

this._loanForcedSaleCounter = 0;
this._lastIntervalReport = 0;
this._loanAllowance = this._loanAllowanceBase;

this._intervalTurnDayCount = this._intervalTurnDayCountReset;

//this._autoRepayment = false;

this._conditionPage = 0;




this._getInterval = function(boolTurn) {
	if (boolTurn === true) return this._loanInterval;
	return (Math.floor((clock.seconds - this._loanStartDate)/this._loanRepaymentInterval))
}

this._repaymentScreen = function() {
	if (guiScreen != "GUI_SCREEN_MISSION") {
	
	var _reports = [0,0,0,this._lastLoanBalance];
	var _missedReports = this._getInterval(this._intervalTurnBased) - this._lastIntervalReport;
	var _oldLoanBalance = this._lastLoanBalance
	var _oldLoanAllowance = this._loanAllowance;
	var _oldLoanCredibility = this._loanCredibility;
	var _oldLoanForcedSaleCounter = this._loanForcedSaleCounter;
	
	if (_missedReports > 0) {
		_reports = this._calculateMissedRates(this._lastLoanBalance,this._lastIntervalReport,this._partialPayment,this._outOfSchedulePayment);
		this._lastIntervalReport = this._getInterval(this._intervalTurnBased);
		this._lastLoanBalance = _reports[3];
		this._loanBalance = _reports[3];
		this._expectedLoanBalance = _reports[3];
		this._loanCredibility += this._calculateReputation(this._partialPayment + this._outOfSchedulePayment,_reports[0]+_reports[1]);
		this._setAllowance();
		if (this._loanAllowance === this._loanAllowanceMinimum && _oldLoanCredibility >= this._loanCredibility) this._loanForcedSaleCounter += 1;
		else if (this._loanAllowance != this._loanAllowanceMinimum && this._loanForcedSaleCounter > 0) this._loanForcedSaleCounter = 0;
		this._outOfSchedulePayment = 0;
		this._partialPayment = 0;
		var _reportText = this._createReport(_missedReports,_oldLoanBalance,_reports[3],_reports[0],_reports[2],_oldLoanAllowance,this._loanAllowance,_oldLoanForcedSaleCounter,this._loanForcedSaleCounter);
	}
	
	var _currentReport = this._calculateLoan(_reports[3],this._partialPayment);
	
	if (this._loanAllowance === this._loanAllowanceMinimum && this._loanForcedSaleCounter > this._loanForcedSaleCounterLimit) {
		this._loanForcedSale();
	}
		
	var choices = {
		"LOANMANAGEMENT_90_EXIT" : "Exit loan menu",
		"LOANMANAGEMENT_10_CONDITIONS" : "Loan conditions"
	};
	
	this._partialPaymentLeft = _currentReport[3];
	var _expectedLoanBalance = _lastLoanBalance + _currentReport[0] + _currentReport[2] - this._partialPayment - this._outOfSchedulePayment;
	this._payment = this._ableToPay(_currentReport[3]);
	
	if (_missedReports === 0) {
		
		if (player.credits === 0) choices["LOANMANAGEMENT_09_NOMONEY"] = {
			text : "Pay an additional sum (Insufficient money)",
			color : "darkGrayColor"
		}
		else choices["LOANMANAGEMENT_09_ADDITIONALPAYMENT"] = {
			text : "Pay an additional sum"
			
		}
		
		if (_currentReport[3] === 0) choices["LOANMANAGEMENT_03_PAY"] = {
			text : "Pay the weekly rate (Done)",
			color : "darkGrayColor"
		}
		else if (0 === this._payment) choices["LOANMANAGEMENT_03_PAY"] = {
			text : "Pay the weekly rate (Insufficient money)",
			color : "darkGrayColor"
		}
		else if (_currentReport[3] === this._payment) choices["LOANMANAGEMENT_03_PAY"] = {
			text : "Pay the weekly rate (" + formatCredits(_currentReport[3],true,true) + ")"
		}
		else choices["LOANMANAGEMENT_03_PAY"] = {
			text : "Partly pay the weekly rate (" + formatCredits(this._payment,true,true) + ")"
		}
	}
	else {
		choices["LOANMANAGEMENT_03_CONTINUE"] = {
			text : "Continue to management"
		}
	}
	
	// autopayment
	//if (this._autoRepayment) choices["LOANMANAGEMENT_01_AUTOPAY"] = "Deactivate auto payment (Stops the automatic withdraw from you account.)";
	//else choices["LOANMANAGEMENT_01_AUTOPAY"] = "Activate auto payment (Withdraws the weekly rate from your account, when docking.)";
	
	
	if (guiScreen != "GUI_SCREEN_MISSION") {
	mission.runScreen({screenID: "loan_management_gui", exitScreen: "GUI_SCREEN_INTERFACES", title: "Loan management", allowInterrupt : true, message:this._formatLineToList("Cash: " + formatCredits(player.credits,true,true), "Next rate due in: " + this._getTimeTillNextInterval(this._intervalTurnBased)+"\n",32,false), choices:choices}, this._loanManagmentChoice.bind(this));
	
	//mission.addMessageText(/*this._formatLineToList("Cash: ",player.credits,15,true) + "\n"*/);
	
	if (_missedReports > 0) {
		
		for (var i = 0; i < _reportText.length; i++) {
			mission.addMessageText(_reportText[i]);
		}
	}
	else {
			mission.addMessageText(this._formatLineToList("Old loan balance: ", _reports[3],15,true) + "\n");
	
			mission.addMessageText(this._formatLineToList("Interest rate: ",_currentReport[0],15,true,"+"));
			mission.addMessageText(this._formatLineToList("Repayment rate: ",_currentReport[1],15,true,"+"));
			mission.addMessageText(this._formatLineToList("Already paid: ",this._partialPayment,15,true,"-"));
			mission.addMessageText(this._formatLineToList("Total payment rate: ",_currentReport[0] + _currentReport[1] - this._partialPayment,15,true) + "\n");
			
			mission.addMessageText(this._formatLineToList("Unscheduled payment: ",this._outOfSchedulePayment,15,true,"-") + "\n");
			
			mission.addMessageText(this._formatLineToList("Expected loan balance: ",_expectedLoanBalance/*this._loanBalance*/,15,true) + "\n");
			
			mission.addMessageText(this._formatLineToList("Cash: ",player.credits,15,true));
			mission.addMessageText(this._formatLineToList("Allowance: ",this._loanAllowance,15,true,"( -"));
			mission.addMessageText(this._formatLineToList("Currently able to pay: ",this._payment,15,true));
		}
	}}
}

this._createReport = function(missedReports,oldLoanBalance,currentLoanBalance,totalInterests,totalDefaulteRates,oldLoanAllowance,loanAllowance,oldLoanForcedSaleCounter,loanForcedSaleCounter) {
	var _i = 0;
	var _returnStringArray = [];
		//if (_missedReports > 0) {
		if (missedReports === 1) {
			_returnStringArray[0] = "Payment report:\n";
		}
		else {
			_returnStringArray[0] = this._formatLineToList("Missed payments: ",missedReports - 1,15,false) +"\n";
		}
			_returnStringArray[1] = this._formatLineToList("Old loan balance: ",oldLoanBalance,15,true);
			_returnStringArray[2] = this._formatLineToList("Total interest rates: ",totalInterests,15,true,"+");
			_returnStringArray[3] = this._formatLineToList("Total default rates: ",totalDefaulteRates,15,true,"+") +"\n";
			_returnStringArray[4] = this._formatLineToList("Current loan balance: ", currentLoanBalance,15,true);
			_i = 5;
			//log("Allowance " + oldLoanAllowance + " "+loanAllowance );
			if (oldLoanAllowance > loanAllowance) {
			_returnStringArray[_i] = "\n As your repayments did not meet our expectations, we are forces to lower your allowance to " + formatCredits(this._loanAllowance,true,true) + ".";
			_i++;
			}
			else if (oldLoanAllowance < loanAllowance) {
			_returnStringArray[_i] = "\n The amount of your repayments earned you a better credibility. We are increasing your allowance to " + formatCredits(this._loanAllowance,true,true) + ".";
			_i++;
			}
			else if (loanAllowance === this._loanAllowanceMinimum && loanForcedSaleCounter > 0) {
				var _string;
				if (this._intervalTurnBased === true) _string = "payment cycle";
				else _string = "week";
				if (loanForcedSaleCounter === oldLoanForcedSaleCounter) {
					_returnStringArray[_i] = "\nYour last payments have increased your credibility, therefore we have postponed the forced sale of the ship for one " + _string + ". Try to further increase your credibility.";
					_i++;
				}
				else if (loanForcedSaleCounter > this._loanForcedSaleCounterLimit) {
					
					_returnStringArray[_i] = "\nThe ship will be sold off.";
					_i++;
				}
				else {
					if (this._loanForcedSaleCounterLimit - loanForcedSaleCounter != 1) _string += "s";
					_returnStringArray[_i] = "\nSadly your credibility is so low, that we soon have to confiscate the ship and sale it. You have " + (this._loanForcedSaleCounterLimit-this._loanForcedSaleCounter) + " " + _string + " left.";
					_i++;
				}
			
			}
		//}
	return _returnStringArray;
}

// Partially based on phkb's $padTextRight in "StationDockControl_Interface" from "Station Dock Control" OXP.
// With kind permission of phkb to update the license to cc by-nc-sa 4.0.
this._formatLineToList = function(inputString,inputValue,returnLength,boolCredits,prefix) {
	var _hairSpace = String.fromCharCode(31);
	var _string;
	if (inputString == null) _string = "";
	else _string = inputString;
	
	var _inputValueString = "";
	if (boolCredits === true) _inputValueString = formatCredits(inputValue,true,true);
	else _inputValueString = inputValue;
	if (prefix) _inputValueString = prefix + " " + _inputValueString;
	
	var _returnStringLength = defaultFont.measureString(_string) + defaultFont.measureString(_inputValueString);
	
	var _hairSpaceLength = defaultFont.measureString(_hairSpace);
	var _padsNeeded = Math.floor((returnLength - _returnStringLength) / _hairSpaceLength);
	if (_padsNeeded < 1)	{
		do {
			_string = _string.substring(0, _string.length - 2) + "…";
		} while (defaultFont.measureString(_string) + defaultFont.measureString(_inputValueString) > returnLength);
		_returnStringLength = defaultFont.measureString(_string) + defaultFont.measureString(_inputValueString);
		_padsNeeded = Math.floor((returnLength - _returnStringLength) / _hairSpaceLength);
	}
	_string +=  new Array(_padsNeeded).join(_hairSpace) + _inputValueString;
	
	if (prefix) {
		var space = true;
		for (var i = prefix.length - 1; i > -1; i--) {
			
			switch(prefix[i]){
				case "(":
					if (space === true) {_string += " "; space = false;}
					_string += ")";
					break;
				case "{":
					if (space === true) {_string += " "; space = false;}
					_string += "}";
					break;
				case "[":
					if (space === true) {_string += " "; space = false;}
					_string += "]";
					break;
				case "<":	
					if (space === true) {_string += " "; space = false;}
					_string += ">";
					break;
				case ">":	
					if (space === true) {_string += " "; space = false;}
					_string += "<";
			}
		}
	}	
	return (_string);
}

this._getTimeTillNextInterval = function (boolTurn) {
	
	if (this._loanBalance <=0) return "never";
	if (boolTurn === true) {
		if (this._intervalTotalTurns - this._intervalTurn !== 1 ) return((this._intervalTotalTurns - this._intervalTurn) + " turns");
		else return((this._intervalTotalTurns - this._intervalTurn) + " turn");
	}
	
	var _timeSeconds = ((Math.floor((clock.seconds - this._loanStartDate)/this._loanRepaymentInterval)+1)*this._loanRepaymentInterval - (clock.seconds - this._loanStartDate));
	var _time = [];
	_time[0] = Math.floor(_timeSeconds/86400);
	_timeSeconds -= _time[0]*86400;
	_time[1] = Math.floor(_timeSeconds/3600);
	_timeSeconds -= _time[1]*3600;
	_time[2] = Math.floor(_timeSeconds/60);
	if (_time[0] != 0) {
		return (_time[0] + " days " + _time[1] + " hrs " + _time[2] + " min");	
	}
	if (_time[1] != 0) {
			return (_time[1] + " hrs " + _time[2] + " min");
	}
	return (_time[2] + " min");
	//return (88 + " days " + 88 + " hrs " + 88 + " min");
}

this._conditionsScreen = function() {
	var _message;
	var choicesCon = {
		"LOANCONDITIONS_90_EXIT" : "Exit loan conditions",
		"LOANCONDITIONS_10_CONDITIONS" : "Next page"
	}
	
	if (this._conditionPage === 0) {
		var _insertions = {
			repaymentRate : this._repaymentRate,
			interestRate : this._interestRate,
			intervalTotalTurns : this._intervalTotalTurns,
			loanAllowanceBase : formatCredits(this._loanAllowanceBase,false,true),
			defaultRate : this._defaultRate,
			outOfScheduleRate : this._outOfScheduleRate
		}
		
		var _turnDockingText = "";
		if (this._intervalTurnsTotalDaysCounter === 1) _turnDockingText = expandMissionText("loan_conditions_turn_day");
		else if (this._intervalTurnsTotalDaysCounter > 1) _turnDockingText = expandMissionText("loan_conditions_turn_days",{number : this._intervalTurnsTotalDaysCounter});
		if (this._intervalTurnDayCountReset < 0) _turnDockingText += expandMissionText("loan_conditions_turn_days_docking");
		_insertions["turnDockingText"] = _turnDockingText;
		
		if (this._intervalTurnBased === true) _message = expandMissionText("loan_agreement_turn",_insertions);
		else _message = expandMissionText("loan_agreement_time", _insertions);
		
	} else {
		_message = expandMissionText("loan_credibility");
		
	}
	player.ship.hudHidden = true;
	mission.runScreen({screenID : "loan_conditions_gui", title:"Loan management", message:_message, choices:choicesCon}, this._loanConditionChoice.bind(this));
	
}

this._loanConditionChoice = function(choice) {
	if (choice === "LOANCONDITIONS_10_CONDITIONS") {
		this._conditionPage++;
		if (this._conditionPage > 1) this._conditionPage = 0;
		mission.exitScreen;
		this._conditionsScreen();
		
	}
	else if (choice === "LOANCONDITIONS_90_EXIT") {
		player.ship.hudHidden = false;
		this._repaymentScreen();
		
	}
	
}

this._loanManagmentChoice = function(choice) {
	if (choice === "LOANMANAGEMENT_01_AUTOPAY") {
		this._autoRepayment = !this._autoRepayment;
		this._repaymentScreen();
		
	}
	else if (choice === "LOANMANAGEMENT_03_PAY") {
		player.credits -= this._payment;
		this._alreadyPaid += this._payment;
		this._partialPayment += this._payment;
		this._loanBalance -= this._payment;
		if (this._loanBalance < 0) this._loanBalance = 0;
		this._repaymentScreen();
	}
	else if (choice === "LOANMANAGEMENT_09_ADDITIONALPAYMENT") {
		mission.exitScreen;
		this._additionalPaymentScreen();
	}
	else if (choice === "LOANMANAGEMENT_90_EXIT") {
		mission.exitScreen;
		this._cashUp = true;
	}
	else if (choice === "LOANMANAGEMENT_10_CONDITIONS") {
		mission.exitScreen;
		this._conditionsScreen();
	}
	else if (choice === "LOANMANAGEMENT_03_CONTINUE" || choice === "LOANMANAGEMENT_09_NOMONEY") {
		mission.exitScreen;
		this._repaymentScreen();
	}
	
	
}

this._additionalPaymentScreen = function() {
	var _stringCreator = function(amount,rate) {
		return ("Pay " + formatCredits(amount,true,true) + " (to pay off " + formatCredits(amount * (1-(rate * 0.01)),true,true) + ")");
	}
	
	if (this._partialPaymentLeft === 0) {
		var choices = {
			"LOANADDITIONAL_90_EXIT" : "Exit pay menu",
			"LOANADDITIONAL_05_PAY100" : "Pay " + formatCredits(100,true,true) + " (to pay off " + formatCredits(100 * (1-(this._outOfScheduleRate*0.01)),true,true) + ")" ,
			"LOANADDITIONAL_04_PAY500" : "Pay " + formatCredits(500,true,true) + " (to pay off " + formatCredits(500 * (1-(this._outOfScheduleRate*0.01)),true,true) + ")" ,
			"LOANADDITIONAL_03_PAY1000" : "Pay " + formatCredits(1000,true,true) + " (to pay off " + formatCredits(1000 * (1-(this._outOfScheduleRate*0.01)),true,true) + ")" ,
			"LOANADDITIONAL_02_PAY5000" : "Pay " + formatCredits(5000,true,true) + " (to pay off " + formatCredits(5000 * (1-(this._outOfScheduleRate*0.01)),true,true) + ")" ,
			"LOANADDITIONAL_01_PAY10000" : "Pay " + formatCredits(10000,true,true) + " (to pay off " + formatCredits(10000 * (1-(this._outOfScheduleRate*0.01)),true,true) + ")" 
		};
		
		if (player.credits < 100 || this._loanBalance < 100 * this._outOfScheduleRate * 0.01 ) choices["LOANADDITIONAL_05_PAY100"] = {
			text : _stringCreator(100,this._outOfScheduleRate),
			color : "darkGrayColor"
		}
		if (player.credits < 500 || this._loanBalance < 500 * this._outOfScheduleRate * 0.01) choices["LOANADDITIONAL_04_PAY500"] = {
			text : _stringCreator(500,this._outOfScheduleRate),
			color : "darkGrayColor"
		}
		if (player.credits < 1000 || this._loanBalance < 1000 * this._outOfScheduleRate * 0.01) choices["LOANADDITIONAL_03_PAY1000"] = {
			text : _stringCreator(1000,this._outOfScheduleRate),
			color : "darkGrayColor"
		}
		if (player.credits < 5000 || this._loanBalance < 5000 * this._outOfScheduleRate * 0.01) choices["LOANADDITIONAL_02_PAY5000"] = {
			text : _stringCreator(5000,this._outOfScheduleRate),
			color : "darkGrayColor"
		}
		if (player.credits < 10000 || this._loanBalance < 10000 * this._outOfScheduleRate * 0.01) choices["LOANADDITIONAL_01_PAY10000"] = {
			text : _stringCreator(10000,this._outOfScheduleRate),
			color : "darkGrayColor"
		}
		if (this._loanBalance < 10000 * (100 - this._outOfScheduleRate) * 0.01 && this._loanBalance > player.credits * (100 - this._outOfScheduleRate) * 0.01) choices["LOANADDITIONAL_00_PAYREST"] = {
			text : _stringCreator((this._loanBalance * (100 + this._outOfScheduleRate) * 0.01),this._outOfScheduleRate),
			color : "darkGrayColor"
		}
		else if (this._loanBalance <= 10000 * (100 - this._outOfScheduleRate) * 0.01 && this._loanBalance <= player.credits * (100 - this._outOfScheduleRate) * 0.01) choices["LOANADDITIONAL_00_PAYREST"] = {
			text : _stringCreator((this._loanBalance * (100 + this._outOfScheduleRate) * 0.01) ,this._outOfScheduleRate)
		}
	}
	else {
		var choices = {
			"LOANADDITIONAL_90_EXIT" : "Exit pay menu"
		};
		/*if (this._loanBalance <= 10000 && player.credits >= this._loanBalance) choices["LOANADDITIONAL_89_ENDLOAN"] = {
			text : "Pay " + formatCredits(this._loanBalance,true,true) + "(Settle debt)"
		}*/
		if (this._partialPaymentLeft >= 10000 && player.credits >= 10000) choices["LOANADDITIONAL_01_PAYPART10000"] = {
			text : "Pay " + formatCredits(10000,true,true)
		}
		if (this._partialPaymentLeft >= 5000 && player.credits >= 5000) {
			choices["LOANADDITIONAL_02_PAYPART5000"] = {
				text : "Pay " + formatCredits(5000,true,true)
			}
		}
		if (this._partialPaymentLeft >= 1000 && player.credits >= 1000) {
			choices["LOANADDITIONAL_03_PAYPART1000"] = {
				text : "Pay " + formatCredits(1000,true,true)
			}
		}
		if (this._partialPaymentLeft >= 500 && player.credits >= 500) {
			choices["LOANADDITIONAL_04_PAYPART500"] = {
				text : "Pay " + formatCredits(500,true,true)
			}
		}
		if (this._partialPaymentLeft >= 100 && player.credits >= 100) {
			choices["LOANADDITIONAL_05_PAYPART100"] = {
				text : "Pay " + formatCredits(100,true,true)
			}
		}
		if (this._partialPaymentLeft <= player.credits)
			choices["LOANADDITIONAL_01_PAYPART"] = {
				text : "Pay " + formatCredits(this._partialPaymentLeft,true,true)
			}
		if (player.credits === 0) choices["LOANADDITIONAL_01_NOMONEY"] = {
				text : "Pay " + formatCredits(0,true,true) + " (Insufficent money)",
				color : "darkGrayColor"
			}
	}
	
	var _currentReport = this._calculateLoan(this._lastLoanBalance,this._partialPayment);
	var _expectedLoanBalance = this._lastLoanBalance + _currentReport[0] + _currentReport[2] - this._partialPayment - this._outOfSchedulePayment;
	
	
	mission.runScreen({screenID: "loan_pay_gui", exitScreen: "GUI_SCREEN_INTERFACES", title: "Loan management", allowInterrupt : true, message:this._formatLineToList("Cash: " + formatCredits(player.credits,true,true), "Next rate due in: " + this._getTimeTillNextInterval(this._intervalTurnBased)+"\n",32,false), choices:choices}, this._additionalPaymentOptions.bind(this));
	
	/*mission.addMessageText(this._formatLineToList("Player's account balance: ",player.credits,15,true) + "\n");
	
	mission.addMessageText(this._formatLineToList("Old loan balance: ",this._lastLoanBalance,15,true) + "\n");
	
	mission.addMessageText(this._formatLineToList("Current loan balance: ",this._loanBalance,15,true) + "\n");
	*/
	//mission.addMessageText(this._formatLineToList("Cash: ",player.credits,15,true) + "\n");
	
	mission.addMessageText(this._formatLineToList("Old loan balance: ", this._lastLoanBalance,15,true) + "\n");
	
	mission.addMessageText(this._formatLineToList("Interest rate: ",_currentReport[0],15,true,"+"));
	mission.addMessageText(this._formatLineToList("Repayment rate: ",_currentReport[1],15,true,"+"));
	mission.addMessageText(this._formatLineToList("Already paid: ",this._partialPayment,15,true,"-"));
	mission.addMessageText(this._formatLineToList("Total payment rate: ",_currentReport[0] + _currentReport[1] - this._partialPayment,15,true) + "\n");
			
	mission.addMessageText(this._formatLineToList("Unscheduled payment: ",this._outOfSchedulePayment,15,true,"-") + "\n");
	
	mission.addMessageText(this._formatLineToList("Expected loan balance: ",_expectedLoanBalance/*this._loanBalance*/,15,true));
	
	
	
}

this._additionalPaymentOptions = function(choice) {
	
	if (choice === "LOANADDITIONAL_90_EXIT") {
		mission.exitScreen;
		this._repaymentScreen();
	}
	if (choice === "LOANADDITIONAL_01_NOMONEY") {
		this._additionalPaymentScreen();
	}
	if (choice === "LOANADDITIONAL_00_PAYREST") {
		this._additionalPayment(this._loanBalance,0);
		this._additionalPaymentScreen();
	}
	
	if (choice === "LOANADDITIONAL_05_PAY100") {
		this._additionalPayment(100,this._outOfScheduleRate);
		this._additionalPaymentScreen();
	}
	else if (choice === "LOANADDITIONAL_04_PAY500") {
		this._additionalPayment(500,this._outOfScheduleRate);
		this._additionalPaymentScreen();
	}
	else if (choice === "LOANADDITIONAL_03_PAY1000") {
		this._additionalPayment(1000,this._outOfScheduleRate);
		this._additionalPaymentScreen();
	}
	else if (choice === "LOANADDITIONAL_02_PAY5000") {
		this._additionalPayment(5000,this._outOfScheduleRate);
		this._additionalPaymentScreen();
	}
	else if (choice === "LOANADDITIONAL_01_PAY10000") {
		this._additionalPayment(10000,this._outOfScheduleRate);
		this._additionalPaymentScreen();
	}
	else if (choice === "LOANADDITIONAL_01_PAYPART") {
		//this._additionalPayment(this._partialPaymentLeft,0);
		player.credits -= this._partialPaymentLeft;
		this._loanBalance -= this._partialPaymentLeft;
		this._partialPayment += this._partialPaymentLeft;
		this._partialPaymentLeft = 0;
		this._additionalPaymentScreen();
	}
	else if (choice === "LOANADDITIONAL_05_PAYPART100") {
		this._additionalPayment(100,0);
		this._additionalPaymentScreen();
	}
	else if (choice === "LOANADDITIONAL_04_PAYPART500") {
		this._additionalPayment(500,0);
		this._additionalPaymentScreen();
	}
	else if (choice === "LOANADDITIONAL_03_PAYPART1000") {
		this._additionalPayment(1000,0);
		this._additionalPaymentScreen();
	}
	else if (choice === "LOANADDITIONAL_02_PAYPART5000") {
		this._additionalPayment(5000,0);
		this._additionalPaymentScreen();
	}
	else if (choice === "LOANADDITIONAL_01_PAYPART10000") {
		this._additionalPayment(10000,0);
		this._additionalPaymentScreen();
	}
	
}

this._additionalPayment = function(payment,rate) {
	if (player.credits >= payment && (this._loanBalance >= (payment * (100 - rate) * 0.01))) {
		player.credits -= payment;
		this._loanBalance -= (payment * (100 - rate) * 0.01);
		if (this._partialPaymentLeft != 0) this._partialPayment += (payment * (100 - rate) * 0.01);
		else this._outOfSchedulePayment += (payment * (100 - rate) * 0.01);
	}
	
}
 
this._addLoanInterface = function(station) {
	station.setInterface("loans_interface", {
		title: "Loan menu",
		category: "Loans",
		summary: "Manage your outstanding loan.",
		callback: this._repaymentScreen.bind(this)
	}
	);
}

this.shipDockedWithStation = function (station) {
	if (station.allegiance === "galcop" && galaxyNumber === this._loanGalaxy) {
	if (station.allegiance === "galcop" && galaxyNumber === this._loanGalaxy && this._intervalTurnBased === true && this._loanBalance > 0 ) {
		this._intervalTurnDayCount = this._intervalTurnDayCountReset;
		this._intervalTurnChanger();
	}
	if (station.allegiance === "galcop" && galaxyNumber === this._loanGalaxy && this._getInterval(this._intervalTurnBased) > this._lastIntervalReport && this._loanBalance > 0 ) {
		//var _reports = this._calculateMissedRates(this._lastLoanBalance,this._lastIntervalReport,this._partialPayment);
		var _reportString = "Loan Report:\nA new loan repayment rate is due.\n";
		var _oldLoanBalance = this._lastLoanBalance
		var _oldLoanAllowance = this._loanAllowance;
		var _oldLoanCredibility = this._loanCredibility;
		var _oldLoanForcedSaleCounter = this._loanForcedSaleCounter;

		var _reports = this._calculateMissedRates(this._lastLoanBalance,this._lastIntervalReport,this._partialPayment,this._outOfSchedulePayment);
		
		this._lastIntervalReport = this._getInterval(this._intervalTurnBased);
		log(_reports[3]);
		this._lastLoanBalance = _reports[3];
		this._loanBalance = _reports[3];
		this._loanCredibility += this._calculateReputation(this._partialPayment+this._outOfSchedulePayment,_reports[0]+_reports[1]);
		this._setAllowance();
		
		if (this._loanAllowance === this._loanAllowanceMinimum && _oldLoanCredibility >= this._loanCredibility) this._loanForcedSaleCounter += 1;
		else if (this._loanAllowance != this._loanAllowanceMinimum && this._loanForcedSaleCounter > 0) this._loanForcedSaleCounter = 0;
		
		this._outOfSchedulePayment = 0;
		this._partialPayment = 0;
		
		var _reportText = this._createReport(this._getInterval(this._intervalTurnBased)-this._lastIntervalReport,_oldLoanBalance,_reports[3],_reports[0],_reports[2],_oldLoanAllowance,this._loanAllowance,_oldLoanForcedSaleCounter,this._loanForcedSaleCounter);
		
		/*if (this._loanAllowance === this._loanAllowanceMinimum && this._loanForcedSaleCounter > this._loanForcedSaleCounterLimit) {
			_reportString = "Message from the station authorities: ''There is a matter to discuss regarding the ownership of your ship. Please cooperate with the Galcop officer, who awaits you at the docking bay.''";
		}
		else {
			for (var i = 0; i < _reportText.length; i++) {
				_reportString += _reportText[i] + "\n";
			}
		}*/
		
		for (var i = 0; i < _reportText.length; i++) {
			_reportString += _reportText[i] + "\n";
		}
		
		player.addMessageToArrivalReport(_reportString);
		var _currentReport = this._calculateLoan(_reports[3],this._partialPayment);
		this._partialPaymentLeft = _currentReport[3];
		
	}
	
		if (this._loanAllowance === this._loanAllowanceMinimum && this._loanForcedSaleCounter > this._loanForcedSaleCounterLimit) {
			player.addMessageToArrivalReport("Message from the station authorities: ''There is a matter to discuss regarding the ownership of your ship. Please cooperate with the Galcop officer, who awaits you at the landing pad.''");
		}
		
		this._addLoanInterface(station);
	}
}

this._loanForcedSale = function() {
	if (player.ship.dockedStation) {
		var _station = player.ship.dockedStation;
		var _mlist = player.ship.manifest;
		var _m,_c,_price,_q,_cap;
		var _sold = false;
		
		for (var i = 0; i<_mlist.length && (player.credits < this._loanBalance); i++) {
			_m = _mlist[i];
			_c = _m[0].commodity;
			_price = _station.market[_c].price;
			_cap = _station.market[_c].capacity;
			_q = _m[0].quantity;
			player.credits += _price*_q/10;
			player.ship.manifest[_c] = 0;
			if (_station.market[_c].quantity + _q < _cap) _station.market[_c].quantity += _q;
			else _station.market[_c].quantity = _cap;
		}
		
		if (player.credits < this._loanBalance) {
			player.credits += player.ship.price*(this._loanForcedSellPrice/100);
			player.replaceShip("vagabond-shuttle-player");
			_sold = true;
		}
		
		player.credits -= this._loanBalance;
		this._loanBalance = 0;
		this._lastLoanBalance = 0;
		this._loanForcedSaleCounter = 0;
		
		if (_sold) {
			player.ship.hudHidden = true;
			player.credits += this._loanForcedSellPriceBonus;
			player.ship.awardEquipment("EQ_LOBSTER_PLUSH");
			mission.runScreen({screenID: "loan_a_new_hope_I", exitScreen: "GUI_SCREEN_INTERFACES", title: "And that's that...", messageKey:"loan_forced_deal_1", choices:{"90_EXIT" : "Okay, go on. I'm still listening."}},
				function(choice) {
					if (choice === "90_EXIT") {
						mission.exitScreen;
						mission.runScreen({screenID: "loan_a_new_hope_II", exitScreen: "GUI_SCREEN_INTERFACES", title: "The Bargain", message:expandMissionText("loan_forced_deal_2",{bonus:formatCredits(this._loanForcedSellPriceBonus,false,true)}), choices:{"90_EXIT" : "Oh my..."}},
							function(choice) {
								if (choice === "90_EXIT") {
									mission.exitScreen;
									mission.runScreen({screenID: "loan_a_new_hope_III", exitScreen: "GUI_SCREEN_INTERFACES", title: "And the adventure continues...", message:expandMissionText("loan_forced_deal_3",{bonus:formatCredits(this._loanForcedSellPriceBonus,false,true)}), choices:{"90_EXIT" : "Swimming through space would have been kinda hard on the lungs anyway."}},
										function(choice) {
											if (choice === "90_EXIT") {
												mission.exitScreen;
												player.ship.hudHidden = false;	
											}
	
										}
									);
								}
							}
						);
					}
				}
			);
		}
		else {
			mission.runScreen({screenID: "loan_wrapup", exitScreen: "GUI_SCREEN_INTERFACES", title: "The Loan: Last Chapter", messageKey:"loan_forced_deal_4", choices:{"90_EXIT" : "Well, I guess this wraps it up."}},
				function(choice) {
					if (choice === "90_EXIT") {
						mission.exitScreen;
					}			
				}
			);
		}
	}
}

this.reportScreenEnded = this.missionScreenEnded = function() {
	if (this._loanBalance > 0)
	if (this._loanAllowance === this._loanAllowanceMinimum && this._loanForcedSaleCounter > this._loanForcedSaleCounterLimit) {
			this._loanForcedSale();
		}
}

this.shipLaunchedFromStation = function(station) {

//if (this._autoRepayment) {
	if (station.allegiance === "galcop" && galaxyNumber === this._loanGalaxy && this._lastIntervalReport < this._getInterval(this._intervalTurnBased) && this._loanBalance > 0) {
		
		var _reports = this._calculateMissedRates(this._lastLoanBalance,this._lastIntervalReport,this._partialPayment,this._outOfSchedulePayment);
		var _reportString = "Loan Report:\nA new loan repayment rate is due.\n";
		var _oldLoanBalance = this._lastLoanBalance
		var _oldLoanAllowance = this._loanAllowance;
		var _oldLoanCredibility = this._loanCredibility;
		var _oldLoanForcedSaleCounter = this._loanForcedSaleCounter;	
		
		this._lastIntervalReport = this._getInterval(this._intervalTurnBased);
		this._lastLoanBalance = _reports[3];
		this._loanBalance = _reports[3];
		this._loanCredibility += this._calculateReputation(this._partialPayment+this._outOfSchedulePayment,_reports[0]+_reports[1]);
		this._setAllowance();
		if (this._loanAllowance === this._loanAllowanceMinimum && _oldLoanCredibility >= this._loanCredibility) this._loanForcedSaleCounter += 1;
		else if (this._loanAllowance != this._loanAllowanceMinimum && this._loanForcedSaleCounter > 0) this._loanForcedSaleCounter = 0;
		this._outOfSchedulePayment = 0;
		this._partialPayment = 0;
		var _reportText = this._createReport(this._getInterval(this._intervalTurnBased)-this._lastIntervalReport,_oldLoanBalance,_reports[3],_reports[0],_reports[2],_oldLoanAllowance,this._loanAllowance,_oldLoanForcedSaleCounter,this._loanForcedSaleCounter);
		for (var i = 0; i < _reportText.length; i++) {
			_reportString += _reportText[i] + "\n";
		}
		
		player.commsMessage(_reportString);
		var _currentReport = this._calculateLoan(_reports[3],this._partialPayment);
		this._partialPaymentLeft = _currentReport[3];
		
		if (this._partialPaymentLeft > 0  && this._loanBalance > 0 ) {
			var _pay = this._ableToPay(this._partialPaymentLeft);
			if (_pay > 0) {
				player.credits -= _pay;
				this._partialPayment += _pay;
				this._loanBalance -= _pay;
				player.commsMessage("Auto-repayment: " + formatCredits(_pay,true,true) + "\nCurrent loan balance: " + formatCredits(this._loanBalance,true,true),5);
			}
		}
	}
//}
}

this._takeLoan = function (newDebt) {
	if (this._loanBalance === 0) this._loanStartDate = Math.floor(clock.seconds/86400)*86400;
	this._loanBalance += newDebt;
	
}

this._loanStartSetup = function() {
	var choicesCon = {
		"LOANCONDITIONS_10_TURN" : "Loan repayment based on a turn schedule",
		"LOANCONDITIONS_11_TIME" : "Loan repayment based on a time schedule"
	};
	
	mission.runScreen({screenID : "loan_setup_gui", title:"Loan Setup", messageKey:"loan_setup", choices:choicesCon}, this._loanStartSetupChoices.bind(this));
}

this._loanStartSetupChoices = function(choice) {
	if (choice === "LOANCONDITIONS_11_TIME") {
		this._intervalTurnBased = false;
		mission.exitScreen;
	}
	if (choice === "LOANCONDITIONS_10_TURN") {
		this._intervalTurnBased = true;
		mission.exitScreen;
	}
}

this.missionScreenOpportunity= function() {
	if (clock.seconds < 180058019400 && this._loanBalance === 0) {
		this._takeLoan(player.ship.price * 0.9);
		this._lastLoanBalance = this._loanBalance;
		this._loanInterval = 0;
		this._loanStartSetup();
		this._lastIntervalReport = this._getInterval(this._intervalTurnBased);
	}
}

this.startUpComplete = function() {
	
	this._loanBalance = 0;
	
	this._loanLoadState();
	
	this._partialPayment = this._lastLoanBalance - this._loanBalance;
	if (this._partialPayment < 0) this._partialPayment = 0;
	this._setAllowance();

	if (player.ship.status === "STATUS_DOCKED") {
		var station = player.ship.dockedStation
	
		if (station.allegiance === "galcop" && galaxyNumber === this._loanGalaxy) {
			this._addLoanInterface(station);
		}
	}
}

this.xmlParser = function (inputString) {
	
	var _string = inputString;
	var _s = "";
	var _sLength = _string.length;
	
	var _node = [];
	_node[0] = [];
	_node[1] = "root";
	_node[2] = {};
	_node[3] = null;
	var _child = 0;
    var n = [];

	var _closure = false;

	for (var i = 0; i < _sLength; i++) {

		if (_string[i] === " ") while (_string[i] === " " && i < _sLength) i++;
		
		if (_string[i] === "<" && i+1 < _sLength) {
			i++;
			
			if (_string[i] === "/") {
				_closure = true;
				i++;
			}
			else {
				_child = _node.length;
				var _ch = [];
				_node[_child] = _ch;
				var _parent = _node;
				_node = _ch;
				_node[0] = _parent;
				_node[2] = {};
				_node[3] = "";
			}

			while (_string[i] != " " && _string[i] != ">" && _string[i] != "/" && i < _sLength) {
				_s += _string[i];
				i++;
			}
			
			if (_closure === true) {
				_closure = false;
				if (_string[i]){
					if (_string[i] != ">") log("Parsing syntax error: " + _node[i] + " ''>'' expected.");
                }
				else log("Parsing error: unexpected end of string.a");
				if (_node[1] != _s) log("Parsing error: <" + _node[1] + "> ends with </" + _s + ">" );
				n = _node[0];
				n[n.length-1] = _node;
				_node = n;
			}
			else _node[1] = _s;
			
			_s = "";
		}
		

		if (_string[i] != ">" && i < _sLength) {
			while (_string[i] != ">" && _string[i] != "/" && i < _sLength) {
				if (_string[i] === " ") while (_string[i] === " " && i < _sLength) i++;
				while (_string[i] != " " && _string[i] != ">" && _string[i] != "/" && _string[i] != "=" && i < _sLength) {
					_s += _string[i];
					i++;
				}
		
				if (_string[i] === " ") while (_string[i] === " " && i < _sLength) i++;
		
				if (_string[i] === "=") {
					i++;
					var _n = _node[2];
					var _attrName = _s; 
					_s = "";
			
					if (_string[i] === " ") while (_string[i] === " " && i < _sLength) i++;
			
					if (_string[i] != "\"" && _string[i] != "\'") log("Parser syntax error: No attribute value found.  \" or \' expected.");
					else {
						if (_string[i] === "\""){
							i++;
							while (_string[i] != "\"" && i < _sLength) {
								_s += _string[i];
								i++;
							}
						i++;
						}
						else if (_string[i] === "\'") {
							i++;
							while (_string[i] != "\'" && i < _sLength) {
								_s += _string[i];
								i++;
							}
						i++;
						}
						if (i >= _sLength) log("Parser error: unexpected end of string.");
						else {
							_n[_attrName] = _s;
							_s = "";
							_node[2] = _n;
						}
					}
					
					while (_string[i] != " " && _string[i] != ">" && _string[i] != "/" && _string[i] != "=" && i < _sLength) {
						_s += _string[i];
						i++;
					}
				}
				else {
					log("Parser syntax error: Attribute " + _s + " has no value. ''='' expected.");
					_s = "";
				}
			}
		}
		 
		if (_string[i] === "/") { 
			i++;
			if ( i < _sLength) {
				if (_string[i] != ">") log("Parser Syntax error: ''>'' expected.");
				else {
					n = _node[0];
					n[n.length-1] = _node;
					_node = n;
				}
			}
			else log("Parser error: unexpected end of string.");	
		}
		else if (_string[i] === ">" && i + 1 < _sLength){ 
			i++;
			_s = "";
			while (_string[i] != "<" && i < _sLength) {
				_s += _string[i];
				i++;
			} 
			if (_string[i] === "<") {
				i--;
				if (_s !== "") {
					_node[3] = _s;
					_s = "";
				}
            }
		}
	}
  
    this.xmlClean(_node);
	
	return _node;
}

this.xmlClean = function(xmlObj) {
  var _node = xmlObj;
  
  _node[0] = null;
  
  for (var i = 4; i < _node.length; i++) {
    _node[i] = xmlClean(_node[i]);
  }
  
  return _node;
}

this.xmlToString = function(xmlObj, rString) {
	var _rString = rString;
	var _xmlNode =  xmlObj;
	var temp = "";
	
	_rString += "<" + _xmlNode[1];
	if (_xmlNode[2] != {}) {
		var n = _xmlNode[2];
		for (var attr in n) {
			_rString += " " + attr + "=\'" +  n[attr] + "\'";
		}
	}
	
	if ((!(_xmlNode[3]) || _xmlNode[3] === "") && _xmlNode.length === 4)
		_rString += "/>";
	else 
		_rString += ">";
	if (_xmlNode[3] && _xmlNode[3] !== "")
		_rString += _xmlNode[3];
    else {
		for (var i = 4; i < _xmlNode.length; i++) {
             temp = this.xmlToString(_xmlNode[i],"");
			_rString += temp;
			temp = "";
		}
	}

	if ((_xmlNode[3] && _xmlNode[3] !== "") || _xmlNode.length > 4)
		_rString += "</" + _xmlNode[1] + ">";
	
	return _rString;
}

this._loanXmlDataSearch = function(xmlNode,nodeName) {
	if (xmlNode[1] === nodeName) return xmlNode[2];
	var n = {};
	for (var i = 4; i < xmlNode.length; i++){
		n = this._loanXmlDataSearch(xmlNode[i],nodeName);
		if (n !== {}) {
			for (var attr in n) log(attr + " : " + n[attr]);
			return n;
		}
	}
	return n;
}

this._loanLoadState = function() {
	
	if (missionVariables.loanData) {
		
		// Backward compatibility to 0.1.0. Will be removed in beta!
		var _missionData = missionVariables.loanData;
		var _data = {};
		
		if (_missionData.slice(0,10) ===  "<loandata>") {
			var xmlTest = this.xmlParser(_missionData);
			this.xmlToString(xmlTest,"");
			_data = this._loanXmlDataSearch(xmlTest,"loan");
		}
		else _data = JSON.parse(_missionData);
		
		//var _data = JSON.parse(missionVariables.loanData)
		
		
		//var xmlTest = this.xmlParser(missionVariables.loanData);
		//this.xmlToString(xmlTest,"");
		//var _data = this._loanXmlDataSearch(xmlTest,"loan");
		
		for (var attr in _data) {
			switch(attr) {
				case "_loanBalance":
					this._loanBalance = parseFloat(_data[attr]);
					break;
				case "_lastLoanBalance":
					this._lastLoanBalance = parseFloat(_data[attr]);
					break;
				case "_intervalTurnBased":
					this._intervalTurnBased = _data[attr];
					break;
				case "_loanInterval":
					this._loanInterval = parseInt(_data[attr]);
					break;
				case "_intervalTurn":
					this._intervalTurn = parseInt(_data[attr]);
					break;
				case "_lastIntervalReport":
					this._lastIntervalReport = parseInt(_data[attr]);
					break;
				case "_loanCredibility":
					this._loanCredibility = parseInt(_data[attr]);
					break;
				case "_loanStartDate":
					this._loanStartDate = parseInt(_data[attr]);
					break;
				case "_payment":
					this._payment = parseFloat(_data[attr]);
					break;
				case "_outOfSchedulePayment":
					this._outOfSchedulePayment = parseFloat(_data[attr]);
					break;
				case "_loanForcedSaleCounter":
					this._loanForcedSaleCounter = parseInt(_data[attr]);
					break;
				case "_intervalTurnDayCount":
					this._intervalTurnDayCount = parseInt(_data[attr]);
					break;
				case "_loanGalaxy":
					this._loanGalaxy = parseInt(_data[attr]);
			}		
		}
	}
}

this.playerWillSaveGame = function() {

	if (this._loanBalance > 0) {
		
		var _data = {
		"_loanBalance" : 			this._loanBalance,
		"_lastLoanBalance" : 		this._lastLoanBalance,
		"_intervalTurnBased" : 		this._intervalTurnBased,
		"_loanInterval" : 			this._loanInterval,
		"_intervalTurn" : 			this._intervalTurn,
		"_lastIntervalReport" : 	this._lastIntervalReport,
		"_loanCredibility" : 		this._loanCredibility,
		"_loanStartDate" : 			this._loanStartDate,
		"_payment" : 				this._payment,
		"_outOfSchedulePayment" :	this._outOfSchedulePayment,
		"_loanForcedSaleCounter" :	this._loanForcedSaleCounter,
		"_intervalTurnDayCount" :	this._intervalTurnDayCount,
		"_loanGalaxy" : 			this._loanGalaxy
		}
		var _saveData = JSON.stringify(_data);
		/*_saveData += "<loandata><loan";
		
		_saveData += " _loanBalance=\'" + 			this._loanBalance + "\'";
		_saveData += " _lastLoanBalance=\'" + 		this._lastLoanBalance + "\'";
		_saveData += " _intervalTurnBased=\'" + 	this._intervalTurnBased + "\'";
		_saveData += " _loanInterval=\'" + 			this._loanInterval + "\'";
		_saveData += " _intervalTurn=\'" + 			this._intervalTurn + "\'";
		_saveData += " _lastIntervalReport=\'" + 	this._lastIntervalReport + "\'";
		_saveData += " _loanCredibility=\'" + 		this._loanCredibility + "\'";
		_saveData += " _loanStartDate=\'" + 		this._loanStartDate + "\'";
		_saveData += " _payment=\'" + 				this._payment + "\'";
		_saveData += " _outOfSchedulePayment=\'" + 	this._outOfSchedulePayment + "\'";
		_saveData += " _loanForcedSaleCounter=\'" + this._loanForcedSaleCounter + "\'";
		_saveData += " _loanGalaxy =\'" + 			this._loanGalaxy + "\'";
		
		_saveData += "/></loandata>";*/

		missionVariables.loanData = _saveData;
	}
	else if (missionVariables.loanData) delete missionVariables.loanData;
	
}

this._calculateMissedRates =function (lastCheckedLoanBalance,lastReportTime,paidRate,outOfScheduleRepayment) {
	
	log("rate: "+paidRate+", Unscheduled: "+outOfScheduleRepayment);
	
	var _outstandingRepayments = this._getInterval(this._intervalTurnBased) - lastReportTime;
	if (_outstandingRepayments < 0) _outstandingRepayments = 0;
	
	var _calcStepLoanDebt = lastCheckedLoanBalance;
	var _paidRate = paidRate;
	var _outOfScheduleRepayment = outOfScheduleRepayment;
	var _interestRateAmount;
	var _repaymentRateAmount;
	var _defaultRateAmount;
	
	if (_outstandingRepayments > 0) {
		var _interestRateAmountTotal = 0;
		var _repaymentRateAmountTotal = 0;
		var _defaultRateAmountTotal = 0;
		
		for (var i = 0; i < _outstandingRepayments; i++) {
			_interestRateAmount = _calcStepLoanDebt * this._interestRate * 0.01;
			if (_interestRateAmount > _paidRate) {
				_interestRate -= _paidRate;
				_paidRate = 0;
			}
			else {
				_paidRate -= _interestRateAmount;
				_interestRateAmount = 0;
			}
			//_interestRateAmount -= _paidRate;
			log("Interest: "+_interestRateAmount);
			_repaymentRateAmount = _calcStepLoanDebt * this._repaymentRate * 0.01;
			//if (_paidRate > 0) {
				_repaymentRateAmount -= _paidRate;
			//}
			log("repaymentRest: "+_repaymentRateAmountTotal);
			log("paid: "+_paidRate);
			_defaultRateAmount = _repaymentRateAmount * this._defaultRate * 0.01;
			_interestRateAmountTotal += _interestRateAmount;
			_repaymentRateAmountTotal += _repaymentRateAmount;
			_defaultRateAmountTotal += _defaultRateAmount;
			_calcStepLoanDebt += _interestRateAmount + _defaultRateAmount - _paidRate - _outOfScheduleRepayment;
			_paidRate = 0;
			_outOfScheduleRepayment = 0;
		}
		return([_interestRateAmountTotal,_repaymentRateAmountTotal,_defaultRateAmountTotal,_calcStepLoanDebt]);
	}
	return([0,0,0,_calcStepLoanDebt]);
}

this._calculateReputation = function(posValue, negValue) {
	log("cred: " + posValue +", " + negValue);
	var _returnReputation = posValue - negValue;
	return Math.floor(_returnReputation/100);
}

this._setAllowance = function() {
	this._loanAllowance = (Math.round(this._loanCredibility/10)/10 + 1) * this._loanAllowanceBase;
	if (this._loanAllowance < this._loanAllowanceMinimum) this._loanAllowance = this._loanAllowanceMinimum;
	//log(this._loanAllowance);
}

this._calculateLoan =function (oldLoanBalance,alreadyPaid) {

	var _interestRateAmount = oldLoanBalance * this._interestRate * 0.01;
	var _repaymentRateAmount = oldLoanBalance * this._repaymentRate * 0.01;
	var _defaultRateAmount = 0;
	
	var _repaymentRate = _interestRateAmount + _repaymentRateAmount;
	var _missingRepaymentRate = _repaymentRate - alreadyPaid;
	_defaultRateAmount = _missingRepaymentRate * this._defaultRate * 0.01;
	
	return([_interestRateAmount,_repaymentRateAmount,_defaultRateAmount,_missingRepaymentRate]);
}

this._ableToPay = function(openPayment) {
	if (player.credits > this._loanAllowance) {
		if (player.credits - this._loanAllowance < openPayment) {
			//log (player.credits - this._loanAllowance);
			return (player.credits - this._loanAllowance);
		}
		else {
			return openPayment;
		}
	}
	return 0;
}

this._intervalTurnChanger = function(turns) {
	var _turns = 1;
	if (turns) _turns = turns;
	this._intervalTurn += _turns;
	if (this._intervalTurn >= this._intervalTotalTurns) {
		this._loanInterval += 1;
		this._intervalTurn -= this._intervalTotalTurns;
	}
	log("Interval turn: " + this._intervalTurn);
}

this._intervalTurnDayCounter = function(increase) {
	var _increase = 1;
	if (increase) _increase = increase;
	this._intervalTurnDayCount += _increase;
	if (this._intervalTurnDayCount >= this._intervalTurnsTotalDaysCounter) {
		this._intervalTurnChanger();
		this._intervalTurnDayCount = 0;
	}
	log("Day turn: " + this._intervalTurnDayCount);
}

this.dayChanged = function() {
	if (this._intervalTurnBased === true) this._intervalTurnDayCounter();
}

this.playerStartedJumpCountdown = function(type, seconds) {
     if (type === "galactic" && galaxyNumber === this._loanGalaxy && this._loanBalance > 0) {
		 player.commsMessage(expandMissionText("loan_galactic_jump_warning",{galNumber : galaxyNumber}),15);
		 player.ship.cancelHyperspaceCountdown();
	 }
}

//}